"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("babel-types"));
const path_1 = __importDefault(require("path"));
const slashChar = path_1.default.sep;
function nameForReactComponent(path) {
    var _a, _b;
    const { parentPath } = path;
    if (!t.isArrowFunctionExpression(path.node) && t.isIdentifier(path.node.id)) {
        return path.node.id;
    }
    // @ts-ignore
    if (t.isVariableDeclarator(parentPath) && t.isIdentifier(parentPath.node.id)) {
        // @ts-ignore
        return parentPath.node.id;
    }
    // @ts-ignore
    if (t.isClassMethod(path.node) && t.isIdentifier((_a = parentPath.parentPath) === null || _a === void 0 ? void 0 : _a.node.id)) {
        // @ts-ignore
        return (_b = parentPath.parentPath) === null || _b === void 0 ? void 0 : _b.node.id;
    }
    return null;
}
function plugin({ types: t, }) {
    return {
        name: 'babel-plugin-react-gen-unique-id',
        visitor: {
            Function(programPath, state) {
                var _a;
                const propertyName = ((_a = state.opts) === null || _a === void 0 ? void 0 : _a.propertyName)
                    ? state.opts.propertyName
                    : 'data-spm';
                // const dirLevel = state.opts?.dirLevel ? state.opts.dirLevel : 1
                const identifier = nameForReactComponent(programPath);
                if (!identifier) {
                    return;
                }
                const splits = state.filename.split(slashChar);
                if (!splits || !splits.length) {
                    return;
                }
                // const dirNames = splits.slice(-1 - dirLevel, -1)
                // const absoluteFilePath = state.filename;
                // const fileName = path.basename(absoluteFilePath).split('.')[0]; // splits[splits.length - 1].split('.')[0]
                const rootDir = state.file.opts.root;
                const relativePathSplits = state.filename.replace(rootDir, '').split('.')[0].split(slashChar);
                const fileIdentifier = `${relativePathSplits.join('_')}_${identifier.name}`;
                const prevLiterals = {};
                programPath.traverse({
                    JSXElement(jsxPath) {
                        let nodeName = '';
                        let dataIDDefined = false;
                        // Traverse once to get the element node name (div, Header, span, etc)
                        jsxPath.traverse({
                            JSXOpeningElement(openingPath) {
                                openingPath.stop(); // Do not visit child nodes again
                                const identifierNode = openingPath.get('name')
                                    .node;
                                nodeName = identifierNode.name;
                                openingPath.traverse({
                                    JSXAttribute(attributePath) {
                                        // If the data attribute doesn't exist, then we append the data attribute
                                        const attributeName = attributePath.get('name').node.name;
                                        if (!dataIDDefined) {
                                            dataIDDefined = attributeName === propertyName;
                                        }
                                    },
                                });
                            },
                        });
                        if (!dataIDDefined && nodeName && nodeName !== 'Fragment') {
                            if (typeof prevLiterals[`${fileIdentifier}_${nodeName}`] ===
                                'undefined') {
                                prevLiterals[`${fileIdentifier}_${nodeName}`] = 0;
                            }
                            else {
                                prevLiterals[`${fileIdentifier}_${nodeName}`] += 1;
                            }
                            const siblingIter = prevLiterals[`${fileIdentifier}_${nodeName}`];
                            jsxPath.node.openingElement.attributes.push(t.jsxAttribute(t.jsxIdentifier(propertyName), t.stringLiteral(`${fileIdentifier}_${nodeName}${siblingIter > 0 ? '_' + siblingIter : ''}`)));
                        }
                    },
                });
            },
        },
    };
}
exports.default = plugin;
//# sourceMappingURL=index.js.map